/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001 TF <tf@denpa.org>
 * All rights reserverd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: $
 */
#define MAIN

#include "aladder.h"

static int
initialize(int argc, char *argv)
{
  char path[FILENAME_MAX];

    alCore.script.data = NULL;
    alCore.script.scene_list = NULL;

    alCore.alternative_num = 0;

    alCore.flag = NULL;
    alCore.cg_flag = NULL;

    alCore.state_stack[0] = STAT_EMPTY;
    alCore.state_stack_depth = 0;

    alCore.text.x = 0;
    alCore.text.y = 0;
    alCore.text.clear = False;

    alCore.wait.per_char = False;
    alCore.wait.per_sentence = False;
    alCore.wait.per_page = False;

    alCore.text_history.y = 0;
    alCore.text_history.loop = False;

    setup_directory();

    sprintf(path, "%s/EData_01.dat", alCore.dir.app_dir);
    alCore.script_arc = open_archive(path);

    sprintf(path, "%s/BData_01.dat", alCore.dir.app_dir);
    alCore.cg_arc = open_archive(path);

    sprintf(path, "%s/jiten.txt", alCore.dir.app_dir);
    dict_init(path);

    ImageInit();

    alCore.dev.tapped = False;
    alCore.brightness = 10;
    
    alCore.work = ImageCreate(WIDTH, HEIGHT);
    alCore.vram = ImageCreate(WIDTH, HEIGHT);

    x11_init(argc, argv);
}

void
destroy(void)
{
    free_script();
    close_archive(alCore.script_arc);

    x11_delete();
}

int
main(int argc, char *argv[])
{
    initialize(argc, argv);

    load_script("tenhashi.txt");
    run_engine();

    destroy();

    return 0;
}

#if 0
/* 
 * ֤Υƥ
 */
int
main(int argc, char *argv[])
{
    Archive *arc;
    int i;
    FILE *fp;
    unsigned char *text;

    arc = open_archive(argv[1]);
    print_archive(arc);
    for (i = 0; i < arc->num; i++) {
	switch (arc->type) {
	case ARC_SCN:
	    fprintf(stderr, "extract: %s\n", arc->item[i].name);
	    text = get_text(arc, arc->item[i].name);
	    fp = fopen(arc->item[i].name, "w");
	    {
		unsigned char *p = text;
		while (*p) {
		    putc(*p++, fp);
		}
	    }
	    fclose(fp);
	    free(text);
	    break;
	case ARC_BMP:
	    get_image(arc, arc->item[i].name);
	    break;
	default:
	    break;
	}
    }
    close_archive(arc);

    return 0;
}
#endif
